#include "mbed.h"

class Flicker
{
public:
    Flicker(PinName pin, float interval)
        :_out(pin),_interval(interval) {
        _out = 1;
        registerNextFlick();
    }

    void flick() {
        _out = !_out;
        registerNextFlick();
    }

    void registerNextFlick() {
        _timer.attach(this, &Flicker::flick, _interval);
    }

private:
    DigitalOut _out;
    float _interval;
    Timeout _timer;
};



int main()
{
    Flicker f1(LED1, 0.5);
    
    while(true){}
}
